



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java中如何模拟真正的同时并发请求？</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java中如何模拟真正的同时并发请求？</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 15:07:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　有时需要测试一下某个功能的并发性能，又不要想借助于其他工具，索性就自己的开发语言，来一个并发请求就最方便了。</p>
<p>　　java中模拟并发请求，自然是很方便的，只要多开几个线程，发起请求就好了。但是，这种请求，一般会存在启动的先后顺序了，算不得真正的同时并发！怎么样才能做到真正的同时并发呢？是本文想说的点，java中提供了闭锁 CountDownLatch, 刚好就用来做这种事就最合适了。</p>
<p>　　只需要：</p>
<p><strong>1. 开启n个线程，加一个闭锁，开启所有线程；</strong></p>
<p><strong> 2. 待所有线程都准备好后，按下开启按钮，就可以真正的发起并发请求了。</strong></p>
<div>
<pre class="prettyprint linenums">package com.test;

import java.io.BufferedReader;<br />
import java.io.IOException;<br />
import java.io.InputStream;<br />
import java.io.InputStreamReader;<br />
import java.io.OutputStream;<br />
import java.net.HttpURLConnection;<br />
import java.net.MalformedURLException;<br />
import java.net.URL;<br />
import java.util.concurrent.CountDownLatch;

public class LatchTest {

    public static void main(String[] args) throws InterruptedException {<br />
        Runnable taskTemp = new Runnable() {

　　　　　　　// 注意，此处是非线程安全的，留坑<br />
            private int iCounter;

            @Override<br />
            public void run() {<br />
                for(int i = 0; i &lt; 10; i++) {<br />
                    // 发起请求<br />
//                    HttpClientOp.doGet("https://www.baidu.com/");<br />
                    iCounter++;<br />
                    System.out.println(System.nanoTime() + " [" + Thread.currentThread().getName() + "] iCounter = " + iCounter);<br />
                    try {<br />
                        Thread.sleep(100);<br />
                    } catch (InterruptedException e) {<br />
                        e.printStackTrace();<br />
                    }<br />
                }<br />
            }<br />
        };

        LatchTest latchTest = new LatchTest();<br />
        latchTest.startTaskAllInOnce(5, taskTemp);<br />
    }

    public long startTaskAllInOnce(int threadNums, final Runnable task) throws InterruptedException {<br />
        final CountDownLatch startGate = new CountDownLatch(1);<br />
        final CountDownLatch endGate = new CountDownLatch(threadNums);<br />
        for(int i = 0; i &lt; threadNums; i++) {<br />
            Thread t = new Thread() {<br />
                public void run() {<br />
                    try {<br />
                        // 使线程在此等待，当开始门打开时，一起涌入门中<br />
                        startGate.await();<br />
                        try {<br />
                            task.run();<br />
                        } finally {<br />
                            // 将结束门减1，减到0时，就可以开启结束门了<br />
                            endGate.countDown();<br />
                        }<br />
                    } catch (InterruptedException ie) {<br />
                        ie.printStackTrace();<br />
                    }<br />
                }<br />
            };<br />
            t.start();<br />
        }<br />
        long startTime = System.nanoTime();<br />
        System.out.println(startTime + " [" + Thread.currentThread() + "] All thread is ready, concurrent going...");<br />
        // 因开启门只需一个开关，所以立马就开启开始门<br />
        startGate.countDown();<br />
        // 等等结束门开启<br />
        endGate.await();<br />
        long endTime = System.nanoTime();<br />
        System.out.println(endTime + " [" + Thread.currentThread() + "] All thread is completed.");<br />
        return endTime - startTime;<br />
    }<br />
}</pre>
</div>
<p>其执行效果如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/830731/201810/830731-20181006055905584-773285157.png" /></p>
<p>httpClientOp 工具类，可以使用 成熟的工具包，也可以自己写一个简要的访问方法，参考如下：</p>
<div>
<pre class="prettyprint linenums">class HttpClientOp {<br />
    public static String doGet(String httpurl) {<br />
        HttpURLConnection connection = null;<br />
        InputStream is = null;<br />
        BufferedReader br = null;<br />
        String result = null;// 返回结果字符串<br />
        try {<br />
            // 创建远程url连接对象<br />
            URL url = new URL(httpurl);<br />
            // 通过远程url连接对象打开一个连接，强转成httpURLConnection类<br />
            connection = (HttpURLConnection) url.openConnection();<br />
            // 设置连接方式：get<br />
            connection.setRequestMethod("GET");<br />
            // 设置连接主机服务器的超时时间：15000毫秒<br />
            connection.setConnectTimeout(15000);<br />
            // 设置读取远程返回的数据时间：60000毫秒<br />
            connection.setReadTimeout(60000);<br />
            // 发送请求<br />
            connection.connect();<br />
            // 通过connection连接，获取输入流<br />
            if (connection.getResponseCode() == 200) {<br />
                is = connection.getInputStream();<br />
                // 封装输入流is，并指定字符集<br />
                br = new BufferedReader(new InputStreamReader(is, "UTF-8"));<br />
                // 存放数据<br />
                StringBuffer sbf = new StringBuffer();<br />
                String temp = null;<br />
                while ((temp = br.readLine()) != null) {<br />
                    sbf.append(temp);<br />
                    sbf.append("\r\n");<br />
                }<br />
                result = sbf.toString();<br />
            }<br />
        } catch (MalformedURLException e) {<br />
            e.printStackTrace();<br />
        } catch (IOException e) {<br />
            e.printStackTrace();<br />
        } finally {<br />
            // 关闭资源<br />
            if (null != br) {<br />
                try {<br />
                    br.close();<br />
                } catch (IOException e) {<br />
                    e.printStackTrace();<br />
                }<br />
            }

            if (null != is) {<br />
                try {<br />
                    is.close();<br />
                } catch (IOException e) {<br />
                    e.printStackTrace();<br />
                }<br />
            }

            connection.disconnect();// 关闭远程连接<br />
        }

        return result;<br />
    }

    public static String doPost(String httpUrl, String param) {

        HttpURLConnection connection = null;<br />
        InputStream is = null;<br />
        OutputStream os = null;<br />
        BufferedReader br = null;<br />
        String result = null;<br />
        try {<br />
            URL url = new URL(httpUrl);<br />
            // 通过远程url连接对象打开连接<br />
            connection = (HttpURLConnection) url.openConnection();<br />
            // 设置连接请求方式<br />
            connection.setRequestMethod("POST");<br />
            // 设置连接主机服务器超时时间：15000毫秒<br />
            connection.setConnectTimeout(15000);<br />
            // 设置读取主机服务器返回数据超时时间：60000毫秒<br />
            connection.setReadTimeout(60000);

            // 默认值为：false，当向远程服务器传送数据/写数据时，需要设置为true<br />
            connection.setDoOutput(true);<br />
            // 默认值为：true，当前向远程服务读取数据时，设置为true，该参数可有可无<br />
            connection.setDoInput(true);<br />
            // 设置传入参数的格式:请求参数应该是 name1=value1&amp;name2=value2 的形式。<br />
            connection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");<br />
            // 设置鉴权信息：Authorization: Bearer da3efcbf-0845-4fe3-8aba-ee040be542c0<br />
            connection.setRequestProperty("Authorization", "Bearer da3efcbf-0845-4fe3-8aba-ee040be542c0");<br />
            // 通过连接对象获取一个输出流<br />
            os = connection.getOutputStream();<br />
            // 通过输出流对象将参数写出去/传输出去,它是通过字节数组写出的<br />
            os.write(param.getBytes());<br />
            // 通过连接对象获取一个输入流，向远程读取<br />
            if (connection.getResponseCode() == 200) {

                is = connection.getInputStream();<br />
                // 对输入流对象进行包装:charset根据工作项目组的要求来设置<br />
                br = new BufferedReader(new InputStreamReader(is, "UTF-8"));

                StringBuffer sbf = new StringBuffer();<br />
                String temp = null;<br />
                // 循环遍历一行一行读取数据<br />
                while ((temp = br.readLine()) != null) {<br />
                    sbf.append(temp);<br />
                    sbf.append("\r\n");<br />
                }<br />
                result = sbf.toString();<br />
            }<br />
        } catch (MalformedURLException e) {<br />
            e.printStackTrace();<br />
        } catch (IOException e) {<br />
            e.printStackTrace();<br />
        } finally {<br />
            // 关闭资源<br />
            if (null != br) {<br />
                try {<br />
                    br.close();<br />
                } catch (IOException e) {<br />
                    e.printStackTrace();<br />
                }<br />
            }<br />
            if (null != os) {<br />
                try {<br />
                    os.close();<br />
                } catch (IOException e) {<br />
                    e.printStackTrace();<br />
                }<br />
            }<br />
            if (null != is) {<br />
                try {<br />
                    is.close();<br />
                } catch (IOException e) {<br />
                    e.printStackTrace();<br />
                }<br />
            }<br />
            // 断开与远程地址url的连接<br />
            connection.disconnect();<br />
        }<br />
        return result;<br />
    }<br />
}</pre>
</div>
<p>　　如上，就可以发起真正的并发请求了。</p>
<p>并发请求操作流程示意图如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/830731/201810/830731-20181005195842363-1499366714.png" /></p>
<p>　　此处设置了一道门，以保证所有线程可以同时生效。但是，此处的同时启动，也只是语言层面的东西，也并非绝对的同时并发。具体的调用还要依赖于CPU个数，线程数及操作系统的线程调度功能等，不过咱们也无需纠结于这些了，重点在于理解原理！</p>
<p><strong>　　与 CountDownLatch 有类似功能的，还有个工具栅栏 CyclicBarrier, 也是提供一个等待所有线程到达某一点后，再一起开始某个动作，效果一致，不过栅栏的目的确实比较纯粹，就是等待所有线程到达，而前面说的闭锁 CountDownLatch 虽然实现的也是所有线程到达后再开始，但是他的触发点其实是 最后那一个开关，所以侧重点是不一样的。</strong></p>
<p>　　简单看一下栅栏是如何实现真正同时并发呢？示例如下：</p>
<div>
<pre class="prettyprint linenums">// 与 闭锁 结构一致<br />
public class LatchTest {

    public static void main(String[] args) throws InterruptedException {

        Runnable taskTemp = new Runnable() {

            private int iCounter;

            @Override<br />
            public void run() {<br />
                // 发起请求<br />
//              HttpClientOp.doGet("https://www.baidu.com/");<br />
                iCounter++;<br />
                System.out.println(System.nanoTime() + " [" + Thread.currentThread().getName() + "] iCounter = " + iCounter);<br />
            }<br />
        };

        LatchTest latchTest = new LatchTest();<br />
//        latchTest.startTaskAllInOnce(5, taskTemp);<br />
        latchTest.startNThreadsByBarrier(5, taskTemp);<br />
    }

    public void startNThreadsByBarrier(int threadNums, Runnable finishTask) throws InterruptedException {<br />
        // 设置栅栏解除时的动作，比如初始化某些值<br />
        CyclicBarrier barrier = new CyclicBarrier(threadNums, finishTask);<br />
        // 启动 n 个线程，与栅栏阀值一致，即当线程准备数达到要求时，栅栏刚好开启，从而达到统一控制效果<br />
        for (int i = 0; i &lt; threadNums; i++) {<br />
            Thread.sleep(100);<br />
            new Thread(new CounterTask(barrier)).start();<br />
        }<br />
        System.out.println(Thread.currentThread().getName() + " out over...");<br />
    }<br />
}

class CounterTask implements Runnable {

    // 传入栅栏，一般考虑更优雅方式<br />
    private CyclicBarrier barrier;

    public CounterTask(final CyclicBarrier barrier) {<br />
        this.barrier = barrier;<br />
    }

    public void run() {<br />
        System.out.println(Thread.currentThread().getName() + " - " + System.currentTimeMillis() + " is ready...");<br />
        try {<br />
            // 设置栅栏，使在此等待，到达位置的线程达到要求即可开启大门<br />
            barrier.await();<br />
        } catch (InterruptedException e) {<br />
            e.printStackTrace();<br />
        } catch (BrokenBarrierException e) {<br />
            e.printStackTrace();<br />
        }<br />
        System.out.println(Thread.currentThread().getName() + " - " + System.currentTimeMillis() + " started...");<br />
    }<br />
}</pre>
</div>
<p>其运行结果如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/830731/201810/830731-20181006055153633-1606466495.png" /></p>
<p>　　各有其应用场景吧，关键在于需求。就本文示例的需求来说，个人更愿意用闭锁一点，因为更可控了。但是代码却是多了，所以看你喜欢吧！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2j6r38.html">WPF时间格式化</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kvym79.html">json对象数组按对象属性排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kyxkr9.html">Ubuntu学习总结-01 用VMware 8安装Ubuntu 12&period;04详细过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjwgj79.html">黄聪：wordpress中remove&lowbar;action、add&lowbar;action、 do&lowbar;action&lpar;&rpar;的hook钩子都有哪些</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j025o0q.html">Java 基础之认识 Annotation</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w15yoq.html">【转】Linux命令之查看文件占用空间大小-du&comma;df</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdg7ok8.html">ServerInfo&period;INI解密</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wr543q.html">Codeforces 482B Interesting Array&lpar;线段树&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge3nez8.html">arm参数传递和返回值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd14149.html">判断是否为JSON对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wx6mgq.html">ketlle windows下的安装&lpar;最基本&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20gx19.html">startActivity进行Hook</a>
		</li>
						<li><a href="https://www.batexi.com/a/q256mvvq.html">浅谈MemCahe</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjdv669.html">eclipse使用struts2找不到action方法或找不到action的错误记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j144v09.html">linux上的文件服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjomo09.html">golang GBK与UTF-8互转的例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm0gdg9.html">大数据系列之分布式计算批处理引擎MapReduce实践-排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/953mmxz8.html">Intro to Python for Data Science Learning 7 -  2D NumPy Arrays</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm7oe49.html">RJ45接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve67g19.html">继电器是如何成为CPU的（1）【转】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxdkm4e9.html">error&colon; command &amp;&num;39&semi;gcc&amp;&num;39&semi; failed with exit status 1</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1z3ne9.html">&lbrack;精华&rsqb;&lbrack;推荐&rsqb; CAS SSO单点登录环境搭建及实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25jovvq.html">python搭建服务器时nginx的有关问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwdzgd8.html">【微信小程序】模仿58同城页面制作以及动态数据加载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwpm3z9.html">maven阿里云仓库配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjpwl79.html">H5新特性---Web Worker---Web Stroage</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jzx15q.html">大面积project&period;pbxproj冲突问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjelwe9.html">log4j-日志记录小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdww0lz9.html">Spring Boot的应用启动器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwwp579.html">Java WebService 简单实例使用JDK</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
